#include <iostream>
#include <fstream>

using namespace std;

int main(int argc,char** argv){
  //Syntaxe correcte
  //Attention l'argument 0 est le nom du programme
  if(argc!=4){
    cout<<"Usage : \033[32mcode fichier_clair fichier_chiffre cle\033[30m"<<endl;
    cout<<"        ou \033[31mfichier_clair\033[30m est un fichier texte et \033[31mcle\033[30m est une lettre minuscule."<<endl;
    cout<<"        Si la cle est 'e', les lettres a,b,c,... seront envoyes sur e,f,g,..."<<endl;
    return -1;
  }

  //Rcupration des arguments
  string nomFichierClair(argv[1]);
  string nomFichierChiffrer(argv[2]);
  string stringCle(argv[3]);

  //Vrification de la cl
  if(stringCle.size()!=1){
    cout<<"\033[31mErreur\033[30m : La cle doit etre de longueur 1."<<endl;
    return -2;
  }
  char cle=stringCle[0];
  if(cle<'a' || cle>'z'){
    cout<<"\033[31mErreur\033[30m : La cle doit etre une lettre minuscule."<<endl;
    return -3;
  }
  int decalage=cle-'a';

  //Ouverture du fichier clair pour lecture
  fstream fichierClair;
  fichierClair.open(nomFichierClair.c_str(),ios::in);
  if(!fichierClair.is_open()){
    cout<<"\033[31mErreur\033[30m : Impossible d'ouvrir le fichier \033[32m"<<nomFichierClair<<"\033[30m en lecture."<<endl;
    return -4;
  }

  //Ouverture du fichier chiffer pour criture
  fstream fichierChiffre;
  fichierChiffre.open(nomFichierChiffrer.c_str(),ios::out);
  if(!fichierChiffre.is_open()){
    cout<<"\033[31mErreur\033[30m : Impossible d'ouvrir le fichier \033[32m"<<nomFichierChiffrer<<"\033[30m en ecriture."<<endl;
    return -5;
  }

 char caractereClair,caractereChiffre;
  //Parcours des caractres du fichier clair
  while(fichierClair.read(&caractereClair,1)>0){
    //La caractre caractereClair est-il une lettre minuscule ?
    if(caractereClair>='a' && caractereClair<='z'){
      //Si oui on le dcale de dcalage
      caractereChiffre=caractereClair+decalage;
      if(caractereChiffre>'z' || caractereChiffre<0){
	caractereChiffre=caractereChiffre-26;
      }
    }
    //Sinon, est-il une lettre majuscule ?
    else if(caractereClair>='A' && caractereClair<='Z'){
      //Si oui on le dcale de dcalage
      caractereChiffre=caractereClair+decalage;
      if(caractereChiffre>'Z' || caractereChiffre<0){
	caractereChiffre=caractereChiffre-26;
      }
    }
    //Sinon, on ne chiffre pas
    else{
      caractereChiffre=caractereClair;
    }
    //On ecrit le caractere chiffre dans fichierChiffre
    fichierChiffre<<(char)caractereChiffre;
  }
  //On ferme les fichiers
  fichierClair.close();
  fichierChiffre.close();
}
